> For the complete documentation index, see [llms.txt](https://docs.variant3d.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.variant3d.com/variant-js-sdk/setting-material-options.md).

# Setting Material Options

### Materials

A minimal material option object looks like this:

```javascript
{
      tag: 'LEATHER',
      meshTag: 'CHAIR'
},
```

Where `meshTag` is the tag of the mesh or group of meshes you want to apply the material to, and `tag` is the tag of the material you want applied.

```javascript
var data = {
    productCode: 'SKU001'
    options: {    
        materials : [
            {
                tag: 'LEATHER',
                meshTag: 'CHAIR'
            },
            {
                tag: 'LEATHER',
                meshTag: 'FOOTSTOOL'
            }            
        ]
    }
};

Variant.launchQuicklook(data);
```

{% hint style="info" %}
You should only include each meshTag once in the meshes array
{% endhint %}

#### Applying Materials to Mesh Groups

When you have tagged a group of meshes, you can apply materials the same as if you had tagged each individual mesh (e.g. `GROUP` contains `MESH1` and `MESH2`, setting  `meshTag:GROUP, tag:RED` will apply the RED material to both.)

Using mesh groups with materials becomes more powerful when you combine setting individual meshes and groups. Setting the material on individual mesh tag will always override any group material set.&#x20;

With the example given above (`GROUP` containing `MESH1` and `MESH2`), if you set the following options:

```javascript
{
    tag: 'RED',
    meshTag: 'GROUP'
},
{
    tag: 'GREEN',
    meshTag: 'MESH1'
}      
```

&#x20;then `MESH1` would be `GREEN`, and `MESH2` would be `RED`.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.variant3d.com/variant-js-sdk/setting-material-options.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
